PaymentEngine={
	cardtypes:[{"id":10,"name":"Visa","ccsource":"V","has3dsecure":true,"accept":true,"seclen":3,"regexp":"^4[0-9]{6,}$","iconname":"visa","globaliris":"VISA","eci":{"full":5,"merchant":6,"none":7}},{"id":20,"name":"MasterCard","ccsource":"M","has3dsecure":true,"accept":true,"seclen":3,"regexp":"^5[1-5][0-9]{5,}$","iconname":"mastercard","globaliris":"MC","eci":{"full":2,"merchant":1,"none":0}},{"id":30,"name":"American Express","ccsource":"A","has3dsecure":false,"accept":true,"seclen":4,"regexp":"^3[47][0-9]{5,}$","iconname":"amex","globaliris":"AMEX","isamex":true},{"id":40,"name":"Diners Club","ccsource":"C","accept":false,"seclen":3,"regexp":"^3(?:0[0-5]|[68][0-9])[0-9]{4,}$","iconname":"diners"},{"id":50,"name":"Discover","ccsource":"D","accept":false,"seclen":3,"regexp":"^6(?:011|5[0-9]{2})[0-9]{3,}$","iconname":"discover"},{"id":60,"name":"JCB","ccsource":"J","accept":false,"seclen":3,"regexp":"^(?:2131|1800|35[0-9]{3})[0-9]{3,}$","iconname":"jcb"}],
	init:function() {
		$.mask.definitions['n']='[01234567890 ]';
		$('.card-details .formfield-carddate').mask('99/99',{placeholder:" "});
		$('.card-details .field-issuenumber').mask('9?99',{placeholder:" "});
		$('.card-details .field-securitycode').mask('9?999',{placeholder:" "});
		$('.card-details input.field-cardnumber').keydown(PaymentEngine.keydownCardNumber);
		$('.card-details input').blur(PaymentEngine.validate);
		$('.card-details select').blur(PaymentEngine.validate);
		$('.card-details select').change(PaymentEngine.validate);
		$('.card-details input').focus(PaymentEngine.gotFocus);
		$('.card-details select').click(PaymentEngine.gotFocus);
		$('.card-details select').focus(PaymentEngine.gotFocus);
	},
	keydownCardNumber:function(ev) {
		var n;
		if(ev.keyCode>=48 && ev.keyCode<=57) n=ev.keyCode-48;
		if(ev.keyCode>=96 && ev.keyCode<=105) n=ev.keyCode-96;
		if(n!=undefined) {
			var val=$(this).val();
			var gaps;
			if(val.charAt(0)=='3' && (val.charAt(1)=='4' || val.charAt(1)=='7')) {
				gaps=[4,11];
				$(this).attr('maxlength',17);
			} else {
				gaps=[4,9,14];
				$(this).attr('maxlength',19);
			}
			if(gaps.indexOf(val.length)>-1) $(this).val(val+' ');
		}
	},
	gotFocus:function() {
		$(this).addClass('had-focus');
	},
	submitPayForm:function(form) {
		var jform=$(form);
		var validation=PaymentEngine.getValidation(jform,false);
		if(validation.errors.length>0) {
			PaymentEngine.displayErrors(validation,jform);
			var msgs=[];
			for(var i=0;i<validation.errors.length;i++) {
				msgs.push(validation.errors[i].msg);
			}
			window.alert(msgs.join('\r\n'));
			validation.errors[0].jfield.focus();
			return false;
		} else {
			return true;
		}
	},
	validate:function() {
		var jform=$(this).parents('.card-details');
		var validation=PaymentEngine.getValidation(jform,true);
		PaymentEngine.displayErrors(validation,jform);
	},
	displayErrors:function(validation,jform) {
		jform.find('.formfield').removeClass('invalid-value');
		jform.find('.errmsg-formfield').html('');
		var jfield;
		for(var i=0;i<validation.errors.length;i++) {
			jfield=validation.errors[i].jfield;
			jfield.addClass('invalid-value');
			jform.find('#errmsg-'+jfield.attr('name')).text(validation.errors[i].msg);
		}
		if(validation.cardtype==null) {
			validation.jcardnumber.css('background-image','none');
		} else {
			validation.jcardnumber.css('background-image','url(/images/icons/creditcards/16/'+validation.cardtype.iconname+'.png)');
		}
	},
	addError:function(retval,jfield,msg) {
		retval.errors.push({msg:msg,jfield:jfield});
		retval.errfieldnames.push(jfield.attr('name'));
	},
	getValidation:function(jform,onlyhadfocus) {
		var retval={errors:[],errfieldnames:[]};
		jform.find('.formfield').each(function() {
			var jfield=$(this);
			var compulsory=jfield.data('compulsory');
			var prompt=jfield.data('prompt');
			if(jfield.hasClass('field-cardnumber')) retval.jcardnumber=jfield;
			if(jfield.hasClass('field-securitycode')) retval.jsecuritycode=jfield;
			if(jfield.hasClass('field-cardexpires')) retval.jcardexpires=jfield;
			if(jfield.hasClass('field-validfrom')) retval.jvalidfrom=jfield;
			var value=jfield.val();
			if(!onlyhadfocus || jfield.hasClass('had-focus')) {
				if(value=='' && compulsory) {
					PaymentEngine.addError(retval,jfield,'Please enter: '+prompt);
				} else if(jfield.hasClass('formfield-carddate') && value!='') {
					var mm=Number(value.substring(0,2));
					if(mm<1 || mm>12) {
						PaymentEngine.addError(retval,jfield,prompt+' must have a month between 1-12');
					}
				}
			}
		});
		var cno=retval.jcardnumber.val();
		cno=cno.replace(/\s/g,'');
		for(var i=0;i<PaymentEngine.cardtypes.length;i++) {
			if(cno.match(PaymentEngine.cardtypes[i].regexp)!=null) {
				retval.cardtype=PaymentEngine.cardtypes[i];
			}
		}
		if(retval.errfieldnames.indexOf('cardnumber')==-1) {
			if(retval.cardtype==null) {
				PaymentEngine.addError(retval,retval.jcardnumber,'Card Number is not a known card type');
			} else {
				if(!retval.cardtype.accept) {
					PaymentEngine.addError(retval,retval.jcardnumber,'Sorry, we do not accept '+retval.cardtype.name);
				} else if(!PaymentEngine.validLuhn(cno)) {
					PaymentEngine.addError(retval,retval.jcardnumber,'Card Number is not a valid credit card number');
				} else if(retval.cardtype.unsupportedcurs!=undefined && retval.cardtype.unsupportedcurs.indexOf(BASKET_CURRENCY_CODE)>-1) {
					PaymentEngine.addError(retval,retval.jcardnumber,'Sorry, we do not accept '+retval.cardtype.name+' with currency '+BASKET_CURRENCY_CODE);
				}
			}
		}
		if(retval.cardtype!=null && retval.jsecuritycode.val()!='') {
			if(retval.cardtype.seclen!=undefined && retval.cardtype.seclen!=retval.jsecuritycode.val().length) {
				PaymentEngine.addError(retval,retval.jsecuritycode,'Security Code must be '+retval.cardtype.seclen+' long for '+retval.cardtype.name+' cards');
			}
		}
		if(retval.errfieldnames.indexOf('cardexpires')==-1 && (!onlyhadfocus || retval.jcardexpires.hasClass('had-focus'))) {
			var carddate=PaymentEngine.getCardDate(retval.jcardexpires);
			if(carddate==null) {
				PaymentEngine.addError(retval,retval.jcardexpires,'Invalid Expiry Date');
			} else if(carddate.months<carddate.curmonths) {
				PaymentEngine.addError(retval,retval.jcardexpires,'Card Expires must be in the future');
			}
		}
		if(retval.errfieldnames.indexOf('validfrom')==-1 && (!onlyhadfocus || retval.jvalidfrom.hasClass('had-focus'))) {
			var carddate=PaymentEngine.getCardDate(retval.jvalidfrom);
			if(carddate!=null && carddate.months>carddate.curmonths) {
				PaymentEngine.addError(retval,retval.jvalidfrom,'Valid From must be in the past');
			}
		}
		return retval;
	},
	getCardDate:function(jfield) {
		var val=jfield.val();
		if(val.length==5) {
			var retval={mm:Number(val.substring(0,2)),yy:Number(val.substring(3,5))};
			if(isNaN(retval.mm)) return;
			if(isNaN(retval.yy)) return;
			retval.months=retval.yy*12+retval.mm-1;
			if(retval.yy>70) retval.months-=12*100;
			var now=new Date();
			retval.curmonths=(now.getFullYear()-2000)*12+now.getMonth();
			return retval;
		}
	},
	validLuhn:function(cardnumber) {
		var i, sum, weight;
		sum=0;
		for (i = 0; i < cardnumber.length - 1; i++) {
			weight = cardnumber.substr(cardnumber.length - (i + 2), 1) * (2 - (i % 2));
			sum += ((weight < 10) ? weight : (weight - 9));
		}
		if (parseInt(cardnumber.substr(cardnumber.length-1)) == ((10 - sum % 10) % 10)) {
			return true;
		} else {
			return false;
		}
	}
}
$(PaymentEngine.init);

